<template>
  <div
    class="mx-auto mt-2 grid max-w-2xl grid-cols-1 gap-x-8 gap-y-16 border-t border-gray-200 pt-10 sm:mt-16 sm:pt-16 lg:mx-0 lg:max-w-none lg:grid-cols-4">
    <article class="flex max-w-xl flex-col col-start-2 col-span-2 items-start justify-between">
      <div class="flex items-center gap-x-4 text-xs">
        <time :datetime="post.datetime" class="text-gray-500">{{ post.date }}</time>
        <a :href="post.category.href" data-testid="categoryTitle"
          class="relative z-10 rounded-full bg-gray-50 px-3 py-1.5 font-medium text-gray-600 hover:bg-gray-100">
          {{ post.category.title }}
        </a>
      </div>
      <div class="group relative">
        <h3 data-testid="postTitle" class="mt-3 text-lg font-semibold leading-6 text-gray-900 group-hover:text-gray-600">
          <a :href="post.href">
            <span class="absolute inset-0">{{ post.title }}</span>
          </a>
        </h3>
        <p class="mt-5 line-clamp-3 text-sm leading-6 text-gray-600" data-testid="description">{{ post.description }}</p>
      </div>
      <div class="grid grid-cols-5 gap-4">
        <div class="relative mt-8 flex items-center gap-x-4 col-span-2">
          <img :src="post.author.imageUrl" alt="authorPicture" class="h-10 w-10 rounded-full bg-gray-50" />
          <div class="text-sm leading-6">
            <p class="font-semibold text-gray-900" data-testid="authorName">
              <a :href="post.author.href">
                <span class="absolute inset-0" />{{ post.author.name }}
              </a>
            </p>
            <p class="text-gray-600" data-testid="authorRole">{{ post.author.role }}</p>
          </div>
        </div>
        <button @click="toggleModal" data-testid="btnPostDelete"
          class="mt-8 col-start-4 h-10 rounded-md bg-red-600 px-3 py-2 text-sm font-semibold text-white shadow-sm hover:bg-red-500 focus-visible:outline focus-visible:outline-2 focus-visible:outline-offset-2 focus-visible:outline-red-500 leading-6">Delete</button>
        <button data-testid="btnEdit"
          class="mt-8 col-start-5 h-10 rounded-md bg-gray-300 px-3 py-2 text-sm font-semibold text-gray-900 shadow-sm hover:bg-gray-200 focus-visible:outline focus-visible:outline-2 focus-visible:outline-offset-2 focus-visible:outline-gray-300 leading-6">Edit</button>
      </div>
    </article>
    <DeleteModal :show="showModal" @close="toggleModal" @delete="deletePost(post.id)" />
  </div>
</template>

<script>
import DeleteModal from '../../Modals/DeleteModal/DeleteModal.vue';

export default {
  name: "SinglePost",
  props: ["post"],
  components: { DeleteModal },
  data() {
    return {
      showModal: false
    }
  },
  methods: {
    toggleModal() {
      this.showModal = !this.showModal;
    },
    deletePost(id) {
      console.log("delete", id);
    }
  },
}
</script>